Program main
! Calculate Ledbetter's anisotropy measure from Stiffnes matrix
use types
use system3x3
use elastic
use constants
use vrml3d

implicit none
double precision, dimension(10300) :: velo_long=0, velo_trans_max=0, velo_trans_min=0,compressibility=0&
                                     ,young=0, poisson_max=0, poisson_min=0
double precision, dimension(3,3) :: Dynmat=0, Eigvec=0
double precision, dimension(3) :: Eigval=0,k=0,v=0,longitud=0
double precision :: theta=0,phi=0,khi=0,k11=0,k12=0,k13=0,k22=0,k23=0,k33=0,longitud_max=0, &
                    Eigval_long_max=0,Eigval_trans_max=0,Eigval_trans_min=10d6, S1111p=1d0, S1122p=0, beta=0, &
                    v11=0,v12=0,v13=0,v22=0,v23=0,v33=0,nu=0,nu_max=0,nu_min=0,nu_maxmax=0d0,nu_minmin=1d0, &
                    nu_maxmax_theta=0,nu_maxmax_phi=0,nu_minmin_theta=0,nu_minmin_phi
integer, dimension(2) :: trans_mode
integer :: i=0,j=0,kk=00,ii=0,jj=0,n_khi,n_phi2=0,long_mode=0,trans_min=0,trans_max=0,inter_theta=0,inter_phi=0,index=0
character(25)  :: outputlog='',output_young_wrl='',output_sound_wrl='',output_compress_wrl='',output_poisson_wrl
           

! get data
call ouvrir

do i=1,6
  do j=1,6
    S(i,j)=S(i,j)*1000 !scale to Tera-1
  enddo
enddo

outputlog=outputfile(1:LEN_TRIM(outputfile))//".log"
output_young_wrl=outputfile(1:LEN_TRIM(outputfile))//"_young.wrl"  
output_sound_wrl=outputfile(1:LEN_TRIM(outputfile))//"_sound.wrl"  
output_poisson_wrl=outputfile(1:LEN_TRIM(outputfile))//"_poisson.wrl"  
output_compress_wrl=outputfile(1:LEN_TRIM(outputfile))//"_compress.wrl"    
open (2, FILE = outputlog)
write (2,*) 'Project   ', title
write (2,*)
write (2,*) 'ElAM Version2.3, 18/02/2008'
write (2,*)
write (2,*) 'Stifness matrix (customary units GPa, but this is not mandatory)';
do ii=1,6; write (2,'(6F7.2)') (C(ii,jj),jj=1,6); enddo; write (2,*)
write (2,*)
write (2,*) 'Compliance matrix (if C in GPa, then in (TPa)-1';
do ii=1,6; write (2,'(6F7.2)') (S(ii,jj),jj=1,6); enddo; write (2,*)

if (n_thetaf.GT.100) then
  n_thetaf=100
  write (2,*) '3dtheta too large, reduced to 100'
endif  
if (n_phif.GT.100) then
  n_phif=100
  write (2,*) '3dphi too large, reduced to 100'
endif  
if (mod(n_theta,n_thetaf).NE.0) then
  n_theta=(n_theta/n_thetaf)*n_thetaf
  write (2,*) '__ n_theta reduced for meshing purposes'
endif
inter_theta=n_theta/n_thetaf
 
if (mod(n_phi,n_phif).NE.0) then
  n_phi=(n_phi/n_phif)*n_phif
  write (2,*) '__ n_phi reduced for meshing purposes'
endif
inter_phi=n_phi/n_phif 
write (2,*)
write (2,*) 'latitude mesh,    calc:',n_theta,'   3d:',n_thetaf
write (2,*) 'longitude mesh,   calc:',n_phi,'   3d:',n_phif


!------------------------------------------------------------
!                     Start double loop on unit wavevectors 
!------------------------------------------------------------
index=0
do i=0,n_theta
   theta=dble(i)/dble(n_theta)*pi
   n_phi2=n_phi;if (i==0 .OR. i==n_theta) n_phi2=0  
   do j=0, n_phi2
      phi=dble(j)/dble(n_phi)*2d0*pi
      ! build the wave vector      
      k(1)=sin(theta)*cos(phi)
      k(2)=sin(theta)*sin(phi)
      k(3)=cos(theta)
     k11=k(1)*k(1)
      k12=k(1)*k(2)
      k13=k(1)*k(3)
      k22=k(2)*k(2)
      k23=k(2)*k(3)
      k33=k(3)*k(3)


      ! ========== Youngs Modulus = (from Nye) ========================================

      S1111p=&
      k11*k11*S(1,1)+2*k12*k12*S(1,2)+2*k13*k13*S(1,3)+2*k12*k13*S(1,4)+2*k11*k13*S(1,5)+2*k11*k12*S(1,6)&
                    +  k22*k22*S(2,2)+2*k23*k23*S(2,3)+2*k22*k23*S(2,4)+2*k12*k23*S(2,5)+2*k12*k22*S(2,6)&
                                     +  k33*k33*S(3,3)+2*k23*k33*S(3,4)+2*k13*k33*S(3,5)+2*k13*k23*S(3,6)&
                                                      +  k23*k23*S(4,4)+2*k13*k23*S(4,5)+2*k12*k23*S(4,6)&
                                                                       +  k13*k13*S(5,5)+2*k12*k13*S(5,6)&
                                                                                        +  k12*k12*S(6,6)
      
      ! ========== Poisson's Ratio (from my calcs) ====================================
      n_khi=180
      nu_max=0
      nu_min=0
      do kk=0,n_khi      
        khi=dble(kk)/dble(n_khi)*pi
        v(1)=cos(theta)*cos(phi)*cos(khi)-sin(phi)*sin(khi)
        v(2)=cos(theta)*sin(phi)*cos(khi)+cos(phi)*sin(khi)
        v(3)=-sin(theta)*cos(khi)
        v11=v(1)*v(1)
        v12=v(1)*v(2)
        v13=v(1)*v(3)
        v22=v(2)*v(2)
        v23=v(2)*v(3)
        v33=v(3)*v(3) 
        S1122p=&
        k11*v11*S(1,1)+(k11*v22+k22*v11)*S(1,2)+(k11*v33+k33*v11)*S(1,3)&
                                +k22*v22*S(2,2)+(k22*v33+k33*v22)*S(2,3)&
                                                         +k33*v33*S(3,3)     
        S1122p=S1122p+&        
        (k11*v23+k23*v11)*S(1,4)+(k11*v13+k13*v11)*S(1,5)+(k11*v12+k12*v11)*S(1,6)&
       +(k22*v23+k23*v22)*S(2,4)+(k22*v13+k13*v22)*S(2,5)+(k22*v12+k12*v22)*S(2,6)&
       +(k33*v23+k23*v33)*S(3,4)+(k33*v13+k13*v33)*S(3,5)+(k33*v12+k12*v33)*S(3,6)&
                 +k23*v23*S(4,4)+(k23*v13+k13*v23)*S(4,5)+(k23*v12+k12*v23)*S(4,6)& 
                                          +k13*v13*S(5,5)+(k13*v12+k12*v13)*S(5,6)& 
                                                                   +k12*v12*S(6,6)         
        nu=-S1122p/S1111p
        if (kk.EQ.0) then 
          nu_max=nu; nu_min=nu;
        else
          if (nu.GE.nu_max) nu_max=nu
          if (nu.LE.nu_min) nu_min=nu
        endif    
      enddo
      if (nu_max.GE.nu_maxmax) then
        nu_maxmax=nu_max
        nu_maxmax_theta=theta
        nu_maxmax_phi=phi
      endif  
      if (nu_min.LE.nu_minmin) then
        nu_minmin=nu_min
        nu_minmin_theta=theta
        nu_minmin_phi=phi
      endif  
      
      ! ========== Linear Compressibility (from Nye) ==================================

      beta=(S(1,1)+S(1,2)+S(1,3))*k11+(S(1,6)+S(2,6)+S(3,6))*k12+(S(1,5)+S(2,5)+S(3,5))*k13&
                                     +(S(1,2)+S(2,2)+S(2,3))*k22+(S(1,4)+S(2,4)+S(3,4))*k23&
                                                                +(S(1,3)+S(2,3)+S(3,3))*k33
      

                                                                                        
      ! ========== Wave velocities = (from Ledebtter/Marmier) =========================

      DynMat(1,1)=C(1,1)*k11+C(6,6)*k22+C(5,5)*k33+2d0*(C(1,6)*k12+C(1,5)*k13+C(5,6)*k23)
      DynMat(2,2)=C(6,6)*k11+C(2,2)*k22+C(4,4)*k33+2d0*(C(2,6)*k12+C(4,6)*k13+C(2,4)*k23)
      DynMat(3,3)=C(5,5)*k11+C(4,4)*k22+C(3,3)*k33+2d0*(C(4,5)*k12+C(3,5)*k13+C(3,4)*k23)      
      DynMat(1,2)=C(1,6)*k11+C(2,6)*k22+C(4,5)*k33+(C(1,2)+C(6,6))*k12+(C(1,4)+C(5,6))*k13+(C(2,5)+C(2,6))*k23
      DynMat(1,3)=C(1,5)*k11+C(4,6)*k22+C(3,5)*k33+(C(1,4)+C(5,6))*k12+(C(1,3)+C(5,5))*k13+(C(3,6)+C(4,5))*k23
      DynMat(2,3)=C(5,6)*k11+C(2,4)*k22+C(3,4)*k33+(C(2,5)+C(4,6))*k12+(C(3,6)+C(4,5))*k13+(C(2,3)+C(4,4))*k23
      DynMat(2,1)=Dynmat(1,2)
      DynMat(3,1)=Dynmat(1,3)
      DynMat(3,2)=Dynmat(2,3)
      
      
	  call DSYEVH3(Dynmat,Eigvec,Eigval)

      do ii=1,3;longitud(ii)=0;do jj=1,3;longitud(ii)=longitud(ii)+k(jj)*Eigvec(jj,ii)      
      enddo;longitud(ii)=abs(longitud(ii));enddo
      
      longitud_max=0;
      do ii=1,2
        do jj=ii+1,3
          if ((longitud(ii) > longitud(jj)) .AND. (longitud(ii) > longitud_max)) then
          long_mode=ii; longitud_max=longitud(ii);endif
          if ((longitud(ii) < longitud(jj)) .AND. (longitud(jj) > longitud_max)) then
          long_mode=jj; longitud_max=longitud(jj);endif
        enddo
      enddo
      jj=0
      do ii=1,3
        if (ii /= long_mode) then
          jj=jj+1;trans_mode(jj)=ii
        endif
      enddo    
      if (Eigval(trans_mode(1)) > Eigval(trans_mode(2))) then
        trans_max=(trans_mode(1))
        trans_min=(trans_mode(2))
      else
        trans_max=(trans_mode(2))
        trans_min=(trans_mode(1))    
      endif

      if (Eigval(long_mode) >Eigval_long_max) Eigval_long_max=Eigval(long_mode)
      if (Eigval(trans_max) >Eigval_trans_max) Eigval_trans_max=Eigval(trans_max)
      if (Eigval(trans_min) <Eigval_trans_min) Eigval_trans_min=Eigval(trans_min)


      if (verbose) then
      write (2,*) "========================================="
      write (2,*) theta, phi
      write (2,*) "Kpoint"
      write (2,'(3F6.2)') k
      write (2,*)
      write (2,*) "Dynamic Matrix"
      do ii=1,3; write (2,'(3F6.2)') (DynMat(ii,jj),jj=1,3); enddo; write (2,*)
      write (2,*)
      write (2,*) "Eigenvalues"
      write (2,'(3F6.2)') Eigval
      write (2,*)
      write (2,*) "Eigenvectors (in columns)"
      do ii=1,3; write (2,'(3F6.2)') (Eigvec(ii,jj),jj=1,3); enddo; write (2,*)
      write (2,*)
      write (2,'(3F6.2)') k
      write (2,*) "Longitudinal", long_mode
      write (2,'(2F6.2)') Eigval(long_mode), longitud(long_mode)
      write (2,'(3F6.2)') (Eigvec(jj,long_mode),jj=1,3)
      write (2,*) "Transverse high", trans_max
      write (2,'(2F6.2)') Eigval(trans_max), longitud(trans_max)
      write (2,'(3F6.2)') (Eigvec(jj,trans_max),jj=1,3)
      write (2,*) "Transverse low", trans_min
      write (2,'(2F6.2)') Eigval(trans_min), longitud(trans_min)
      write (2,'(3F6.2)') (Eigvec(jj,trans_min),jj=1,3)
      endif

      ! ===============================================================================
      
      if ((mod(i,inter_theta).EQ.0).AND.(mod(j,inter_phi).EQ.0)) then
        velo_long(index)=Eigval(long_mode)
        velo_trans_max(index)=Eigval(trans_max)
        velo_trans_min(index)=Eigval(trans_min)
        if (S1111p.ne.0d0) then
          young(index)=1000d0/S1111p
        else
          young(index)=0d0
        endif  
        compressibility(index)=beta
        poisson_max(index)=nu_max
        poisson_min(index)=nu_min        
        index=index+1
!      write (2,*) "========================================="
!      write (2,*) theta, phi
!      write (2,*) "Kpoint"
!      write (2,'(3F6.2)') k
!      write (2,*) S1111p, nu_min, nu_max                
      endif


   enddo
enddo

call vrml3d_calculate_spheroid

if (do_sound) then 
   open (4, FILE = output_sound_wrl)
   call vrml3d_header
   call vrml3d_shape_open
   call vrml3d_spheroid
   call vrml3d_points(velo_trans_max)
   call vrml3d_shape_appearance(.0,.0,.8,.5)
   call vrml3d_shape_close
   call vrml3d_shape_open
   call vrml3d_spheroid
   call vrml3d_points(velo_trans_min)
   call vrml3d_shape_appearance(.5,.0,.0,.0)
   call vrml3d_shape_close
   call vrml3d_shape_open
   call vrml3d_spheroid
   call vrml3d_points(velo_long)
   call vrml3d_shape_appearance(.0,.5,.0,.5)
   call vrml3d_shape_close
   call vrml3d_end
   close(4)
endif

if (do_poisson) then 
   open (4, FILE = output_poisson_wrl)
   call vrml3d_header
   call vrml3d_shape_open
   call vrml3d_spheroid
   call vrml3d_points(poisson_max)
   call vrml3d_shape_appearance(.0,.0,.8,.5)
   call vrml3d_shape_close
   call vrml3d_shape_open
   call vrml3d_spheroid
   call vrml3d_color_sign(poisson_min,.0,.9,.0,.9,.0,.0)   
   call vrml3d_points(poisson_min)
   call vrml3d_shape_appearance(.5,.0,.0,0.)
   call vrml3d_shape_close
   call vrml3d_end
   close(4)
endif

if (do_young) then 
   open (4, FILE = output_young_wrl)
   call vrml3d_header
   call vrml3d_shape_open
   call vrml3d_spheroid
   call vrml3d_points(young)
   call vrml3d_shape_appearance(.0,.5,.5,.0)
   call vrml3d_shape_close
   call vrml3d_end
   close(4)
endif

if (do_compress) then 
   open (4, FILE = output_compress_wrl)
   call vrml3d_header
   call vrml3d_shape_open
   call vrml3d_spheroid
   call vrml3d_color_sign(compressibility,.0,.9,.0,.9,.0,.0)
   call vrml3d_points(compressibility)
   call vrml3d_shape_appearance(.0,.0,.0,.0)
   call vrml3d_shape_close
   call vrml3d_end
   close(4)
endif 



   
write (2,*) "========================================="
write (2,*) "Accoustic Modes "
write (2,*) "  Max   Min "
write (2,'(2F6.2)') Eigval_trans_max,Eigval_trans_min
write (2,*)
write (2,*) "Zener (Cubic)"
write (2,'(a,F6.2)') "A=   ", 2*C(4,4)/(C(1,1)-C(1,2))
write (2,*) "Ledebetter's"
write (2,'(a,F6.2)') "A*=  ",Eigval_trans_max/Eigval_trans_min
write (2,*) "========================================="
write (2,*)
write (2,*)
write (2,*)
write (2,*)

write (2,*) "========================================="
write (2,*) "Poisson's Ratio "
write (2,*) "  Max   Min "
write (2,'(2F6.2)') nu_maxmax,nu_minmin
k(1)=sin(nu_maxmax_theta)*cos(nu_maxmax_phi)
k(2)=sin(nu_maxmax_theta)*sin(nu_maxmax_phi)
k(3)=cos(nu_maxmax_theta)
write (2,*) "  Direction for Max"
write (2,*) "  Theta   Phi"
write (2,'(2F6.2)') nu_maxmax_theta,nu_maxmax_phi
write (2,*) "  x    y    z"
write (2,'(3F6.2)') k(1),k(2),k(3)
k(1)=sin(nu_minmin_theta)*cos(nu_minmin_phi)
k(2)=sin(nu_minmin_theta)*sin(nu_minmin_phi)
k(3)=cos(nu_minmin_theta)
write (2,*) "  Direction for Min"
write (2,*) "  Theta   Phi"
write (2,'(2F6.2)') nu_minmin_theta,nu_minmin_phi
write (2,*) "  x    y    z"
write (2,'(3F6.2)') k(1),k(2),k(3)

write (2,*) "========================================="
write (2,*)
write (2,*) "ElAM completed"
close(2)

end
