subroutine ouvrir
use types
use elastic
use vrml3d
use system3x3

implicit none

character(20)  :: keywrd=''
integer :: i=0,j=0
integer, dimension(6) :: indx=0
double precision :: C1=0,C2=0,C3=0

open (3, FILE = 'input.txt')

!default
title="ElAM CODE"
outputfile="ElAM"
n_theta=24
n_phi=24
n_phif=12
n_thetaf=12
do i=1,6
  do j=i,6
    C(i,j)=0d0
  enddo
enddo
C(1,1)=29d0
C(1,2)=11d0
C(1,3)=8d0
C(2,2)=29d0
C(2,3)=8d0
C(3,3)=32d0
C(4,4)=8d0
C(5,5)=8d0
C(6,6)=9d0   

!read input
read(3,'(a8)') keywrd

do while (keywrd(1:4).ne.'stop')

  if (keywrd(1:4).eq.'titl') then
     read (3,*) title

  else if (keywrd(1:4).eq.'outp') then
     read (3,*) outputfile

  else if (keywrd(1:4).eq.'verb') then
     verbose=.TRUE.

  else if (keywrd(1:5).eq.'young') then
     do_young=.TRUE.

  else if (keywrd(1:8).eq.'compress') then
     do_compress=.TRUE.

  else if (keywrd(1:7).eq.'poisson') then
     do_poisson=.TRUE.

  else if (keywrd(1:5).eq.'sound') then
     do_sound=.TRUE.



  else if (keywrd(1:4).eq.'thet') then
    read (3,*) n_theta

  else if (keywrd(1:3).eq.'phi') then
    read (3,*) n_phi

  else if (keywrd(1:4).eq.'3dth') then
    read (3,*) n_thetaf
  else if (keywrd(1:4).eq.'3dph') then
    read (3,*) n_phif
    
  !================================================================================
  else if (keywrd(1:4).eq.'cubi') then
    read (3,*) C(1,1), C(4,4), C(1,2)
    C(2,2)=C(1,1);C(3,3)=C(1,1)
    C(2,1)=C(1,2);C(1,3)=C(1,2);C(3,1)=C(1,2);C(2,3)=C(1,2);C(3,2)=C(1,2)
    C(5,5)=C(4,4);C(6,6)=C(4,4)

    C1=(C(1,1)-C(1,2))*(C(1,1)+2D0*C(1,2)) 
    S(1,1)= (C(1,1)+C(1,2))/C1
    S(1,2)= -C(1,2)/C1
    S(4,4)= 1D0/C(4,4)
    S(2,2)=S(1,1);S(3,3)=S(1,1)
    S(2,1)=S(1,2);S(1,3)=S(1,2);S(3,1)=S(1,2);S(2,3)=S(1,2);S(3,2)=S(1,2)
    S(5,5)=S(4,4);S(6,6)=S(4,4)
    
  !================================================================================
  else if (keywrd(1:4).eq.'hexa') then
    read (3,*) C(1,1), C(3,3), C(4,4), C(1,2), C(1,3)
    C(2,2)=C(1,1)
    C(2,1)=C(1,2)
    C(3,1)=C(1,3);C(2,3)=C(1,3);C(3,2)=C(1,3)
    C(5,5)=C(4,4)
    C(6,6)=(C(1,1)-C(1,2))/2d0

    C1=C(3,3)*(C(1,1)+C(1,2))-2D0*C(1,3)**2 
    S(1,1)=(C(3,3)/C1+1/(C(1,1)-C(1,2)))/2D0
    S(1,2)=(C(3,3)/C1-1/(C(1,1)-C(1,2)))/2D0
    S(1,3)=-C(1,3)/C1
    S(3,3)=(C(1,1)+C(1,2))/C1
    S(4,4)=1d0/C(4,4)
    S(2,2)=S(1,1)
    S(2,1)=S(1,2)
    S(3,1)=S(1,3);S(2,3)=S(1,3);S(3,2)=S(1,3)
    S(5,5)=S(4,4)
    S(6,6)=(S(1,1)-S(1,2))*2d0  ! carefulllllll
    
    
  !================================================================================
  else if (keywrd(1:4).eq.'tetr') then
    read (3,*) C(1,1), C(3,3), C(4,4), C(6,6), C(1,2), C(1,3), C(1,6)
    C(2,2)=C(1,1)
    C(2,1)=C(1,2)
    C(3,1)=C(1,3);C(2,3)=C(1,3);C(3,2)=C(1,3)
    C(5,5)=C(4,4)
    C(6,1)=C(1,6);C(2,6)=-C(1,6);C(6,2)=-C(1,6)

    C1=2*C(1,1)*C(3,3)*C(1,6)**2+2*C(1,2)*C(3,3)*C(1,6)**2&
    +2*C(1,1)*C(1,3)**2*C(6,6)-2*C(1,2)*C(1,3)**2*C(6,6)&
    -C(1,1)**2*C(3,3)*C(6,6)+C(1,2)**2*C(3,3)*C(6,6)-4*C(1,3)**2*C(1,6)**2
    C2=C(1,1)*C(3,3)+C(1,2)*C(3,3)-2*C(1,3)**2
    C3=C(1,1)*C(6,6)-C(1,2)*C(6,6)-2*C(1,6)**2
    S(1,1)=(-C(1,1)*C(3,3)*C(6,6)+C(3,3)*C(1,6)**2+C(1,3)**2*C(6,6))/C1
    S(3,3)=(C(1,1)+C(1,2))/C2
    S(4,4)=1/C(4,4)
    S(6,6)=(C(1,1)-C(1,2))/C3
    S(1,2)=(C(1,2)*C(3,3)*C(6,6)+C(3,3)*C(1,6)**2-C(1,3)**2*C(6,6))/C1    
    S(1,3)=-C(1,3)/C2
    S(1,6)=-C(1,6)/C3
    S(2,2)=S(1,1)
    S(2,1)=S(1,2)
    S(3,1)=S(1,3);S(2,3)=S(1,3);S(3,2)=S(1,3)
    S(5,5)=S(4,4)
    S(6,1)=S(1,6);S(2,6)=-S(1,6);S(6,2)=-S(1,6)
    
    
   
    
  !================================================================================
  else if (keywrd(1:4).eq.'trig') then
    read (3,*) C(1,1), C(3,3), C(4,4), C(1,2), C(1,3), C(1,4), C(1,5)
    C(2,2)=C(1,1)
    C(2,1)=C(1,2)
    C(3,1)=C(1,3);C(2,3)=C(1,3);C(3,2)=C(1,3)
    C(5,5)=C(4,4)
    C(6,6)=(C(1,1)-C(1,2))/2d0
    C(4,1)=C(1,4);C(2,4)=-C(1,4);C(4,2)=-C(1,4);C(5,6)=C(1,4);C(6,5)=C(1,4)
    C(5,1)=C(1,5);C(2,5)=-C(1,5);C(5,2)=-C(1,5);C(4,6)=-C(1,5);C(6,4)=-C(1,5)
    
  !================================================================================
  else if (keywrd(1:4).eq.'orth') then
    read (3,*) C(1,1), C(2,2),C(3,3), C(4,4), C(5,5), C(1,2), C(1,3), C(2,3)
    C(2,1)=C(1,2)
    C(3,1)=C(1,3)
    C(3,2)=C(2,3)

  !================================================================================

  else if (keywrd(1:2).eq.'C ') then
      do i=1,6
        read (3,*) (C(i,j),j=1,6)
      enddo
     C(2,1)=C(1,2)
     C(3,1)=C(1,3)
     C(3,2)=C(2,3)
   endif
   read(3,'(a8)') keywrd   
enddo

if (S(1,1).EQ.0d0) then
do i=1,6
  do j=1,6
    CP(i,j)=C(i,j)
  enddo
enddo
  CALL MIGS(CP,6,S,indx)
endif	  

end	subroutine ouvrir